config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

config etc/xrdp/xrdp-xinitrc.new
config etc/xrdp/rsakeys.ini.new
config etc/xrdp/sesman.ini.new
config etc/xrdp/xrdp.ini.new
preserve_perms etc/rc.d/rc.xrdp.new
( cd usr/lib64/xrdp ; rm -rf libxrdpapi.so.0 )
( cd usr/lib64/xrdp ; ln -sf libxrdpapi.so.0.0.0 libxrdpapi.so.0 )
( cd usr/lib64/xrdp ; rm -rf libscp.so.0 )
( cd usr/lib64/xrdp ; ln -sf libscp.so.0.0.0 libscp.so.0 )
( cd usr/lib64/xrdp ; rm -rf libxrdpapi.so )
( cd usr/lib64/xrdp ; ln -sf libxrdpapi.so.0.0.0 libxrdpapi.so )
( cd usr/lib64/xrdp ; rm -rf libxrdp.so )
( cd usr/lib64/xrdp ; ln -sf libxrdp.so.0.0.0 libxrdp.so )
( cd usr/lib64/xrdp ; rm -rf libcommon.so )
( cd usr/lib64/xrdp ; ln -sf libcommon.so.0.0.0 libcommon.so )
( cd usr/lib64/xrdp ; rm -rf libcommon.so.0 )
( cd usr/lib64/xrdp ; ln -sf libcommon.so.0.0.0 libcommon.so.0 )
( cd usr/lib64/xrdp ; rm -rf libscp.so )
( cd usr/lib64/xrdp ; ln -sf libscp.so.0.0.0 libscp.so )
( cd usr/lib64/xrdp ; rm -rf libxrdp.so.0 )
( cd usr/lib64/xrdp ; ln -sf libxrdp.so.0.0.0 libxrdp.so.0 )
